use crate::generic::{Field, Generic, Product};

impl<A, B> Generic for (A, B) {
    type Representation = Product<A, Field<B>>;

    fn generalize(self) -> Self::Representation {
        let (l, r) = self;
        Product {
            left: l,
            right: Field { value: r }
        }
    }

    fn specialize(rep: Self::Representation) -> Self {
        let Product {
            left: a,
            right: Field { value: b },
        } = rep;
        (a, b)
    }
}
